<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CommodityType UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesCommodityType extends AbstractStructBase
{
    /**
     * The FreightClass
     * @var string
     */
    public $FreightClass;
    /**
     * The NMFC
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesNMFCCommodityType
     */
    public $NMFC;
    /**
     * Constructor method for CommodityType
     * @uses Ups_ratesCommodityType::setFreightClass()
     * @uses Ups_ratesCommodityType::setNMFC()
     * @param string $freightClass
     * @param \Ups_rates\UPSratesStruct\Ups_ratesNMFCCommodityType $nMFC
     */
    public function __construct($freightClass = null, \Ups_rates\UPSratesStruct\Ups_ratesNMFCCommodityType $nMFC = null)
    {
        $this
            ->setFreightClass($freightClass)
            ->setNMFC($nMFC);
    }
    /**
     * Get FreightClass value
     * @return string|null
     */
    public function getFreightClass()
    {
        return $this->FreightClass;
    }
    /**
     * Set FreightClass value
     * @param string $freightClass
     * @return \Ups_rates\UPSratesStruct\Ups_ratesCommodityType
     */
    public function setFreightClass($freightClass = null)
    {
        // validation for constraint: string
        if (!is_null($freightClass) && !is_string($freightClass)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($freightClass, true), gettype($freightClass)), __LINE__);
        }
        $this->FreightClass = $freightClass;
        return $this;
    }
    /**
     * Get NMFC value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesNMFCCommodityType|null
     */
    public function getNMFC()
    {
        return $this->NMFC;
    }
    /**
     * Set NMFC value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesNMFCCommodityType $nMFC
     * @return \Ups_rates\UPSratesStruct\Ups_ratesCommodityType
     */
    public function setNMFC(\Ups_rates\UPSratesStruct\Ups_ratesNMFCCommodityType $nMFC = null)
    {
        $this->NMFC = $nMFC;
        return $this;
    }
}
