<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FRSShipmentType UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesFRSShipmentType extends AbstractStructBase
{
    /**
     * The TransportationCharges
     * @var \Ups_rates\UPSratesStruct\Ups_ratesTransportationChargesType
     */
    public $TransportationCharges;
    /**
     * The FreightDensityRate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesFreightDensityRateType
     */
    public $FreightDensityRate;
    /**
     * The HandlingUnits
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType[]
     */
    public $HandlingUnits;
    /**
     * Constructor method for FRSShipmentType
     * @uses Ups_ratesFRSShipmentType::setTransportationCharges()
     * @uses Ups_ratesFRSShipmentType::setFreightDensityRate()
     * @uses Ups_ratesFRSShipmentType::setHandlingUnits()
     * @param \Ups_rates\UPSratesStruct\Ups_ratesTransportationChargesType $transportationCharges
     * @param \Ups_rates\UPSratesStruct\Ups_ratesFreightDensityRateType $freightDensityRate
     * @param \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType[] $handlingUnits
     */
    public function __construct(\Ups_rates\UPSratesStruct\Ups_ratesTransportationChargesType $transportationCharges = null, \Ups_rates\UPSratesStruct\Ups_ratesFreightDensityRateType $freightDensityRate = null, array $handlingUnits = array())
    {
        $this
            ->setTransportationCharges($transportationCharges)
            ->setFreightDensityRate($freightDensityRate)
            ->setHandlingUnits($handlingUnits);
    }
    /**
     * Get TransportationCharges value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesTransportationChargesType|null
     */
    public function getTransportationCharges()
    {
        return $this->TransportationCharges;
    }
    /**
     * Set TransportationCharges value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesTransportationChargesType $transportationCharges
     * @return \Ups_rates\UPSratesStruct\Ups_ratesFRSShipmentType
     */
    public function setTransportationCharges(\Ups_rates\UPSratesStruct\Ups_ratesTransportationChargesType $transportationCharges = null)
    {
        $this->TransportationCharges = $transportationCharges;
        return $this;
    }
    /**
     * Get FreightDensityRate value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesFreightDensityRateType|null
     */
    public function getFreightDensityRate()
    {
        return $this->FreightDensityRate;
    }
    /**
     * Set FreightDensityRate value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesFreightDensityRateType $freightDensityRate
     * @return \Ups_rates\UPSratesStruct\Ups_ratesFRSShipmentType
     */
    public function setFreightDensityRate(\Ups_rates\UPSratesStruct\Ups_ratesFreightDensityRateType $freightDensityRate = null)
    {
        $this->FreightDensityRate = $freightDensityRate;
        return $this;
    }
    /**
     * Get HandlingUnits value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType[]|null
     */
    public function getHandlingUnits()
    {
        return $this->HandlingUnits;
    }
    /**
     * This method is responsible for validating the values passed to the setHandlingUnits method
     * This method is willingly generated in order to preserve the one-line inline validation within the setHandlingUnits method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateHandlingUnitsForArrayConstraintsFromSetHandlingUnits(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $fRSShipmentTypeHandlingUnitsItem) {
            // validation for constraint: itemType
            if (!$fRSShipmentTypeHandlingUnitsItem instanceof \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType) {
                $invalidValues[] = is_object($fRSShipmentTypeHandlingUnitsItem) ? get_class($fRSShipmentTypeHandlingUnitsItem) : sprintf('%s(%s)', gettype($fRSShipmentTypeHandlingUnitsItem), var_export($fRSShipmentTypeHandlingUnitsItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The HandlingUnits property can only contain items of type \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set HandlingUnits value
     * @throws \InvalidArgumentException
     * @param \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType[] $handlingUnits
     * @return \Ups_rates\UPSratesStruct\Ups_ratesFRSShipmentType
     */
    public function setHandlingUnits(array $handlingUnits = array())
    {
        // validation for constraint: array
        if ('' !== ($handlingUnitsArrayErrorMessage = self::validateHandlingUnitsForArrayConstraintsFromSetHandlingUnits($handlingUnits))) {
            throw new \InvalidArgumentException($handlingUnitsArrayErrorMessage, __LINE__);
        }
        $this->HandlingUnits = $handlingUnits;
        return $this;
    }
    /**
     * Add item to HandlingUnits value
     * @throws \InvalidArgumentException
     * @param \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType $item
     * @return \Ups_rates\UPSratesStruct\Ups_ratesFRSShipmentType
     */
    public function addToHandlingUnits(\Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType) {
            throw new \InvalidArgumentException(sprintf('The HandlingUnits property can only contain items of type \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->HandlingUnits[] = $item;
        return $this;
    }
}
