<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HandlingUnitsResponseType UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesHandlingUnitsResponseType extends AbstractStructBase
{
    /**
     * The Quantity
     * @var string
     */
    public $Quantity;
    /**
     * The Type
     * @var \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType
     */
    public $Type;
    /**
     * The Dimensions
     * @var \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsDimensionsType
     */
    public $Dimensions;
    /**
     * The AdjustedHeight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesAdjustedHeightType
     */
    public $AdjustedHeight;
    /**
     * Constructor method for HandlingUnitsResponseType
     * @uses Ups_ratesHandlingUnitsResponseType::setQuantity()
     * @uses Ups_ratesHandlingUnitsResponseType::setType()
     * @uses Ups_ratesHandlingUnitsResponseType::setDimensions()
     * @uses Ups_ratesHandlingUnitsResponseType::setAdjustedHeight()
     * @param string $quantity
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $type
     * @param \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsDimensionsType $dimensions
     * @param \Ups_rates\UPSratesStruct\Ups_ratesAdjustedHeightType $adjustedHeight
     */
    public function __construct($quantity = null, \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $type = null, \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsDimensionsType $dimensions = null, \Ups_rates\UPSratesStruct\Ups_ratesAdjustedHeightType $adjustedHeight = null)
    {
        $this
            ->setQuantity($quantity)
            ->setType($type)
            ->setDimensions($dimensions)
            ->setAdjustedHeight($adjustedHeight);
    }
    /**
     * Get Quantity value
     * @return string|null
     */
    public function getQuantity()
    {
        return $this->Quantity;
    }
    /**
     * Set Quantity value
     * @param string $quantity
     * @return \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: string
        if (!is_null($quantity) && !is_string($quantity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($quantity, true), gettype($quantity)), __LINE__);
        }
        $this->Quantity = $quantity;
        return $this;
    }
    /**
     * Get Type value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $type
     * @return \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType
     */
    public function setType(\Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $type = null)
    {
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Dimensions value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsDimensionsType|null
     */
    public function getDimensions()
    {
        return $this->Dimensions;
    }
    /**
     * Set Dimensions value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsDimensionsType $dimensions
     * @return \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType
     */
    public function setDimensions(\Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsDimensionsType $dimensions = null)
    {
        $this->Dimensions = $dimensions;
        return $this;
    }
    /**
     * Get AdjustedHeight value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesAdjustedHeightType|null
     */
    public function getAdjustedHeight()
    {
        return $this->AdjustedHeight;
    }
    /**
     * Set AdjustedHeight value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesAdjustedHeightType $adjustedHeight
     * @return \Ups_rates\UPSratesStruct\Ups_ratesHandlingUnitsResponseType
     */
    public function setAdjustedHeight(\Ups_rates\UPSratesStruct\Ups_ratesAdjustedHeightType $adjustedHeight = null)
    {
        $this->AdjustedHeight = $adjustedHeight;
        return $this;
    }
}
