<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PackageServiceOptionsType UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesPackageServiceOptionsType extends AbstractStructBase
{
    /**
     * The DeliveryConfirmation
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesDeliveryConfirmationType
     */
    public $DeliveryConfirmation;
    /**
     * The AccessPointCOD
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsAccessPointCODType
     */
    public $AccessPointCOD;
    /**
     * The COD
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesCODType
     */
    public $COD;
    /**
     * The DeclaredValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesInsuredValueType
     */
    public $DeclaredValue;
    /**
     * The ShipperDeclaredValue
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesShipperDeclaredValueType
     */
    public $ShipperDeclaredValue;
    /**
     * The ShipperReleaseIndicator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ShipperReleaseIndicator;
    /**
     * The ProactiveIndicator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ProactiveIndicator;
    /**
     * The RefrigerationIndicator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $RefrigerationIndicator;
    /**
     * The Insurance
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesInsuranceType
     */
    public $Insurance;
    /**
     * The UPSPremiumCareIndicator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $UPSPremiumCareIndicator;
    /**
     * The HazMat
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesHazMatType
     */
    public $HazMat;
    /**
     * The DryIce
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesDryIceType
     */
    public $DryIce;
    /**
     * Constructor method for PackageServiceOptionsType
     * @uses Ups_ratesPackageServiceOptionsType::setDeliveryConfirmation()
     * @uses Ups_ratesPackageServiceOptionsType::setAccessPointCOD()
     * @uses Ups_ratesPackageServiceOptionsType::setCOD()
     * @uses Ups_ratesPackageServiceOptionsType::setDeclaredValue()
     * @uses Ups_ratesPackageServiceOptionsType::setShipperDeclaredValue()
     * @uses Ups_ratesPackageServiceOptionsType::setShipperReleaseIndicator()
     * @uses Ups_ratesPackageServiceOptionsType::setProactiveIndicator()
     * @uses Ups_ratesPackageServiceOptionsType::setRefrigerationIndicator()
     * @uses Ups_ratesPackageServiceOptionsType::setInsurance()
     * @uses Ups_ratesPackageServiceOptionsType::setUPSPremiumCareIndicator()
     * @uses Ups_ratesPackageServiceOptionsType::setHazMat()
     * @uses Ups_ratesPackageServiceOptionsType::setDryIce()
     * @param \Ups_rates\UPSratesStruct\Ups_ratesDeliveryConfirmationType $deliveryConfirmation
     * @param \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsAccessPointCODType $accessPointCOD
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCODType $cOD
     * @param \Ups_rates\UPSratesStruct\Ups_ratesInsuredValueType $declaredValue
     * @param \Ups_rates\UPSratesStruct\Ups_ratesShipperDeclaredValueType $shipperDeclaredValue
     * @param string $shipperReleaseIndicator
     * @param string $proactiveIndicator
     * @param string $refrigerationIndicator
     * @param \Ups_rates\UPSratesStruct\Ups_ratesInsuranceType $insurance
     * @param string $uPSPremiumCareIndicator
     * @param \Ups_rates\UPSratesStruct\Ups_ratesHazMatType $hazMat
     * @param \Ups_rates\UPSratesStruct\Ups_ratesDryIceType $dryIce
     */
    public function __construct(\Ups_rates\UPSratesStruct\Ups_ratesDeliveryConfirmationType $deliveryConfirmation = null, \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsAccessPointCODType $accessPointCOD = null, \Ups_rates\UPSratesStruct\Ups_ratesCODType $cOD = null, \Ups_rates\UPSratesStruct\Ups_ratesInsuredValueType $declaredValue = null, \Ups_rates\UPSratesStruct\Ups_ratesShipperDeclaredValueType $shipperDeclaredValue = null, $shipperReleaseIndicator = null, $proactiveIndicator = null, $refrigerationIndicator = null, \Ups_rates\UPSratesStruct\Ups_ratesInsuranceType $insurance = null, $uPSPremiumCareIndicator = null, \Ups_rates\UPSratesStruct\Ups_ratesHazMatType $hazMat = null, \Ups_rates\UPSratesStruct\Ups_ratesDryIceType $dryIce = null)
    {
        $this
            ->setDeliveryConfirmation($deliveryConfirmation)
            ->setAccessPointCOD($accessPointCOD)
            ->setCOD($cOD)
            ->setDeclaredValue($declaredValue)
            ->setShipperDeclaredValue($shipperDeclaredValue)
            ->setShipperReleaseIndicator($shipperReleaseIndicator)
            ->setProactiveIndicator($proactiveIndicator)
            ->setRefrigerationIndicator($refrigerationIndicator)
            ->setInsurance($insurance)
            ->setUPSPremiumCareIndicator($uPSPremiumCareIndicator)
            ->setHazMat($hazMat)
            ->setDryIce($dryIce);
    }
    /**
     * Get DeliveryConfirmation value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesDeliveryConfirmationType|null
     */
    public function getDeliveryConfirmation()
    {
        return $this->DeliveryConfirmation;
    }
    /**
     * Set DeliveryConfirmation value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesDeliveryConfirmationType $deliveryConfirmation
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public function setDeliveryConfirmation(\Ups_rates\UPSratesStruct\Ups_ratesDeliveryConfirmationType $deliveryConfirmation = null)
    {
        $this->DeliveryConfirmation = $deliveryConfirmation;
        return $this;
    }
    /**
     * Get AccessPointCOD value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsAccessPointCODType|null
     */
    public function getAccessPointCOD()
    {
        return $this->AccessPointCOD;
    }
    /**
     * Set AccessPointCOD value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsAccessPointCODType $accessPointCOD
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public function setAccessPointCOD(\Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsAccessPointCODType $accessPointCOD = null)
    {
        $this->AccessPointCOD = $accessPointCOD;
        return $this;
    }
    /**
     * Get COD value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesCODType|null
     */
    public function getCOD()
    {
        return $this->COD;
    }
    /**
     * Set COD value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCODType $cOD
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public function setCOD(\Ups_rates\UPSratesStruct\Ups_ratesCODType $cOD = null)
    {
        $this->COD = $cOD;
        return $this;
    }
    /**
     * Get DeclaredValue value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesInsuredValueType|null
     */
    public function getDeclaredValue()
    {
        return $this->DeclaredValue;
    }
    /**
     * Set DeclaredValue value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesInsuredValueType $declaredValue
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public function setDeclaredValue(\Ups_rates\UPSratesStruct\Ups_ratesInsuredValueType $declaredValue = null)
    {
        $this->DeclaredValue = $declaredValue;
        return $this;
    }
    /**
     * Get ShipperDeclaredValue value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipperDeclaredValueType|null
     */
    public function getShipperDeclaredValue()
    {
        return $this->ShipperDeclaredValue;
    }
    /**
     * Set ShipperDeclaredValue value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesShipperDeclaredValueType $shipperDeclaredValue
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public function setShipperDeclaredValue(\Ups_rates\UPSratesStruct\Ups_ratesShipperDeclaredValueType $shipperDeclaredValue = null)
    {
        $this->ShipperDeclaredValue = $shipperDeclaredValue;
        return $this;
    }
    /**
     * Get ShipperReleaseIndicator value
     * @return string|null
     */
    public function getShipperReleaseIndicator()
    {
        return $this->ShipperReleaseIndicator;
    }
    /**
     * Set ShipperReleaseIndicator value
     * @param string $shipperReleaseIndicator
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public function setShipperReleaseIndicator($shipperReleaseIndicator = null)
    {
        // validation for constraint: string
        if (!is_null($shipperReleaseIndicator) && !is_string($shipperReleaseIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shipperReleaseIndicator, true), gettype($shipperReleaseIndicator)), __LINE__);
        }
        $this->ShipperReleaseIndicator = $shipperReleaseIndicator;
        return $this;
    }
    /**
     * Get ProactiveIndicator value
     * @return string|null
     */
    public function getProactiveIndicator()
    {
        return $this->ProactiveIndicator;
    }
    /**
     * Set ProactiveIndicator value
     * @param string $proactiveIndicator
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public function setProactiveIndicator($proactiveIndicator = null)
    {
        // validation for constraint: string
        if (!is_null($proactiveIndicator) && !is_string($proactiveIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($proactiveIndicator, true), gettype($proactiveIndicator)), __LINE__);
        }
        $this->ProactiveIndicator = $proactiveIndicator;
        return $this;
    }
    /**
     * Get RefrigerationIndicator value
     * @return string|null
     */
    public function getRefrigerationIndicator()
    {
        return $this->RefrigerationIndicator;
    }
    /**
     * Set RefrigerationIndicator value
     * @param string $refrigerationIndicator
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public function setRefrigerationIndicator($refrigerationIndicator = null)
    {
        // validation for constraint: string
        if (!is_null($refrigerationIndicator) && !is_string($refrigerationIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($refrigerationIndicator, true), gettype($refrigerationIndicator)), __LINE__);
        }
        $this->RefrigerationIndicator = $refrigerationIndicator;
        return $this;
    }
    /**
     * Get Insurance value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesInsuranceType|null
     */
    public function getInsurance()
    {
        return $this->Insurance;
    }
    /**
     * Set Insurance value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesInsuranceType $insurance
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public function setInsurance(\Ups_rates\UPSratesStruct\Ups_ratesInsuranceType $insurance = null)
    {
        $this->Insurance = $insurance;
        return $this;
    }
    /**
     * Get UPSPremiumCareIndicator value
     * @return string|null
     */
    public function getUPSPremiumCareIndicator()
    {
        return $this->UPSPremiumCareIndicator;
    }
    /**
     * Set UPSPremiumCareIndicator value
     * @param string $uPSPremiumCareIndicator
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public function setUPSPremiumCareIndicator($uPSPremiumCareIndicator = null)
    {
        // validation for constraint: string
        if (!is_null($uPSPremiumCareIndicator) && !is_string($uPSPremiumCareIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uPSPremiumCareIndicator, true), gettype($uPSPremiumCareIndicator)), __LINE__);
        }
        $this->UPSPremiumCareIndicator = $uPSPremiumCareIndicator;
        return $this;
    }
    /**
     * Get HazMat value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesHazMatType|null
     */
    public function getHazMat()
    {
        return $this->HazMat;
    }
    /**
     * Set HazMat value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesHazMatType $hazMat
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public function setHazMat(\Ups_rates\UPSratesStruct\Ups_ratesHazMatType $hazMat = null)
    {
        $this->HazMat = $hazMat;
        return $this;
    }
    /**
     * Get DryIce value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesDryIceType|null
     */
    public function getDryIce()
    {
        return $this->DryIce;
    }
    /**
     * Set DryIce value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesDryIceType $dryIce
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public function setDryIce(\Ups_rates\UPSratesStruct\Ups_ratesDryIceType $dryIce = null)
    {
        $this->DryIce = $dryIce;
        return $this;
    }
}
