<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for PackageType UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesPackageType extends AbstractStructBase
{
    /**
     * The PackagingType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType
     */
    public $PackagingType;
    /**
     * The Dimensions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesDimensionsType
     */
    public $Dimensions;
    /**
     * The DimWeight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesPackageWeightType
     */
    public $DimWeight;
    /**
     * The PackageWeight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesPackageWeightType
     */
    public $PackageWeight;
    /**
     * The Commodity
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesCommodityType
     */
    public $Commodity;
    /**
     * The LargePackageIndicator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $LargePackageIndicator;
    /**
     * The PackageServiceOptions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType
     */
    public $PackageServiceOptions;
    /**
     * The AdditionalHandlingIndicator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AdditionalHandlingIndicator;
    /**
     * The UPSPremier
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesUPSPremierType
     */
    public $UPSPremier;
    /**
     * Constructor method for PackageType
     * @uses Ups_ratesPackageType::setPackagingType()
     * @uses Ups_ratesPackageType::setDimensions()
     * @uses Ups_ratesPackageType::setDimWeight()
     * @uses Ups_ratesPackageType::setPackageWeight()
     * @uses Ups_ratesPackageType::setCommodity()
     * @uses Ups_ratesPackageType::setLargePackageIndicator()
     * @uses Ups_ratesPackageType::setPackageServiceOptions()
     * @uses Ups_ratesPackageType::setAdditionalHandlingIndicator()
     * @uses Ups_ratesPackageType::setUPSPremier()
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $packagingType
     * @param \Ups_rates\UPSratesStruct\Ups_ratesDimensionsType $dimensions
     * @param \Ups_rates\UPSratesStruct\Ups_ratesPackageWeightType $dimWeight
     * @param \Ups_rates\UPSratesStruct\Ups_ratesPackageWeightType $packageWeight
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCommodityType $commodity
     * @param string $largePackageIndicator
     * @param \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType $packageServiceOptions
     * @param string $additionalHandlingIndicator
     * @param \Ups_rates\UPSratesStruct\Ups_ratesUPSPremierType $uPSPremier
     */
    public function __construct(\Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $packagingType = null, \Ups_rates\UPSratesStruct\Ups_ratesDimensionsType $dimensions = null, \Ups_rates\UPSratesStruct\Ups_ratesPackageWeightType $dimWeight = null, \Ups_rates\UPSratesStruct\Ups_ratesPackageWeightType $packageWeight = null, \Ups_rates\UPSratesStruct\Ups_ratesCommodityType $commodity = null, $largePackageIndicator = null, \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType $packageServiceOptions = null, $additionalHandlingIndicator = null, \Ups_rates\UPSratesStruct\Ups_ratesUPSPremierType $uPSPremier = null)
    {
        $this
            ->setPackagingType($packagingType)
            ->setDimensions($dimensions)
            ->setDimWeight($dimWeight)
            ->setPackageWeight($packageWeight)
            ->setCommodity($commodity)
            ->setLargePackageIndicator($largePackageIndicator)
            ->setPackageServiceOptions($packageServiceOptions)
            ->setAdditionalHandlingIndicator($additionalHandlingIndicator)
            ->setUPSPremier($uPSPremier);
    }
    /**
     * Get PackagingType value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType|null
     */
    public function getPackagingType()
    {
        return $this->PackagingType;
    }
    /**
     * Set PackagingType value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $packagingType
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageType
     */
    public function setPackagingType(\Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $packagingType = null)
    {
        $this->PackagingType = $packagingType;
        return $this;
    }
    /**
     * Get Dimensions value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesDimensionsType|null
     */
    public function getDimensions()
    {
        return $this->Dimensions;
    }
    /**
     * Set Dimensions value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesDimensionsType $dimensions
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageType
     */
    public function setDimensions(\Ups_rates\UPSratesStruct\Ups_ratesDimensionsType $dimensions = null)
    {
        $this->Dimensions = $dimensions;
        return $this;
    }
    /**
     * Get DimWeight value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageWeightType|null
     */
    public function getDimWeight()
    {
        return $this->DimWeight;
    }
    /**
     * Set DimWeight value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesPackageWeightType $dimWeight
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageType
     */
    public function setDimWeight(\Ups_rates\UPSratesStruct\Ups_ratesPackageWeightType $dimWeight = null)
    {
        $this->DimWeight = $dimWeight;
        return $this;
    }
    /**
     * Get PackageWeight value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageWeightType|null
     */
    public function getPackageWeight()
    {
        return $this->PackageWeight;
    }
    /**
     * Set PackageWeight value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesPackageWeightType $packageWeight
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageType
     */
    public function setPackageWeight(\Ups_rates\UPSratesStruct\Ups_ratesPackageWeightType $packageWeight = null)
    {
        $this->PackageWeight = $packageWeight;
        return $this;
    }
    /**
     * Get Commodity value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesCommodityType|null
     */
    public function getCommodity()
    {
        return $this->Commodity;
    }
    /**
     * Set Commodity value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCommodityType $commodity
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageType
     */
    public function setCommodity(\Ups_rates\UPSratesStruct\Ups_ratesCommodityType $commodity = null)
    {
        $this->Commodity = $commodity;
        return $this;
    }
    /**
     * Get LargePackageIndicator value
     * @return string|null
     */
    public function getLargePackageIndicator()
    {
        return $this->LargePackageIndicator;
    }
    /**
     * Set LargePackageIndicator value
     * @param string $largePackageIndicator
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageType
     */
    public function setLargePackageIndicator($largePackageIndicator = null)
    {
        // validation for constraint: string
        if (!is_null($largePackageIndicator) && !is_string($largePackageIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($largePackageIndicator, true), gettype($largePackageIndicator)), __LINE__);
        }
        $this->LargePackageIndicator = $largePackageIndicator;
        return $this;
    }
    /**
     * Get PackageServiceOptions value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType|null
     */
    public function getPackageServiceOptions()
    {
        return $this->PackageServiceOptions;
    }
    /**
     * Set PackageServiceOptions value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType $packageServiceOptions
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageType
     */
    public function setPackageServiceOptions(\Ups_rates\UPSratesStruct\Ups_ratesPackageServiceOptionsType $packageServiceOptions = null)
    {
        $this->PackageServiceOptions = $packageServiceOptions;
        return $this;
    }
    /**
     * Get AdditionalHandlingIndicator value
     * @return string|null
     */
    public function getAdditionalHandlingIndicator()
    {
        return $this->AdditionalHandlingIndicator;
    }
    /**
     * Set AdditionalHandlingIndicator value
     * @param string $additionalHandlingIndicator
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageType
     */
    public function setAdditionalHandlingIndicator($additionalHandlingIndicator = null)
    {
        // validation for constraint: string
        if (!is_null($additionalHandlingIndicator) && !is_string($additionalHandlingIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($additionalHandlingIndicator, true), gettype($additionalHandlingIndicator)), __LINE__);
        }
        $this->AdditionalHandlingIndicator = $additionalHandlingIndicator;
        return $this;
    }
    /**
     * Get UPSPremier value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesUPSPremierType|null
     */
    public function getUPSPremier()
    {
        return $this->UPSPremier;
    }
    /**
     * Set UPSPremier value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesUPSPremierType $uPSPremier
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPackageType
     */
    public function setUPSPremier(\Ups_rates\UPSratesStruct\Ups_ratesUPSPremierType $uPSPremier = null)
    {
        $this->UPSPremier = $uPSPremier;
        return $this;
    }
}
