<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RateRequest UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesRateRequest extends AbstractStructBase
{
    /**
     * The Request
     * Meta information extracted from the WSDL
     * - ref: common:Request
     * @var \Ups_rates\UPSratesStruct\Ups_ratesRequestType
     */
    public $Request;
    /**
     * The PickupType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType
     */
    public $PickupType;
    /**
     * The CustomerClassification
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType
     */
    public $CustomerClassification;
    /**
     * The Shipment
     * @var \Ups_rates\UPSratesStruct\Ups_ratesShipmentType
     */
    public $Shipment;
    /**
     * Constructor method for RateRequest
     * @uses Ups_ratesRateRequest::setRequest()
     * @uses Ups_ratesRateRequest::setPickupType()
     * @uses Ups_ratesRateRequest::setCustomerClassification()
     * @uses Ups_ratesRateRequest::setShipment()
     * @param \Ups_rates\UPSratesStruct\Ups_ratesRequestType $request
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $pickupType
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $customerClassification
     * @param \Ups_rates\UPSratesStruct\Ups_ratesShipmentType $shipment
     */
    public function __construct(\Ups_rates\UPSratesStruct\Ups_ratesRequestType $request = null, \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $pickupType = null, \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $customerClassification = null, \Ups_rates\UPSratesStruct\Ups_ratesShipmentType $shipment = null)
    {
        $this
            ->setRequest($request)
            ->setPickupType($pickupType)
            ->setCustomerClassification($customerClassification)
            ->setShipment($shipment);
    }
    /**
     * Get Request value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRequestType|null
     */
    public function getRequest()
    {
        return $this->Request;
    }
    /**
     * Set Request value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesRequestType $request
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRateRequest
     */
    public function setRequest(\Ups_rates\UPSratesStruct\Ups_ratesRequestType $request = null)
    {
        $this->Request = $request;
        return $this;
    }
    /**
     * Get PickupType value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType|null
     */
    public function getPickupType()
    {
        return $this->PickupType;
    }
    /**
     * Set PickupType value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $pickupType
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRateRequest
     */
    public function setPickupType(\Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $pickupType = null)
    {
        $this->PickupType = $pickupType;
        return $this;
    }
    /**
     * Get CustomerClassification value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType|null
     */
    public function getCustomerClassification()
    {
        return $this->CustomerClassification;
    }
    /**
     * Set CustomerClassification value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $customerClassification
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRateRequest
     */
    public function setCustomerClassification(\Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $customerClassification = null)
    {
        $this->CustomerClassification = $customerClassification;
        return $this;
    }
    /**
     * Get Shipment value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipmentType|null
     */
    public function getShipment()
    {
        return $this->Shipment;
    }
    /**
     * Set Shipment value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesShipmentType $shipment
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRateRequest
     */
    public function setShipment(\Ups_rates\UPSratesStruct\Ups_ratesShipmentType $shipment = null)
    {
        $this->Shipment = $shipment;
        return $this;
    }
}
