<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RatedPackageType UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesRatedPackageType extends AbstractStructBase
{
    /**
     * The TransportationCharges
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesChargesType
     */
    public $TransportationCharges;
    /**
     * The BaseServiceCharge
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesChargesType
     */
    public $BaseServiceCharge;
    /**
     * The ServiceOptionsCharges
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesChargesType
     */
    public $ServiceOptionsCharges;
    /**
     * The TotalCharges
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesChargesType
     */
    public $TotalCharges;
    /**
     * The Weight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Weight;
    /**
     * The BillingWeight
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesBillingWeightType
     */
    public $BillingWeight;
    /**
     * The Accessorial
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesAccessorialType[]
     */
    public $Accessorial;
    /**
     * The ItemizedCharges
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesChargesType[]
     */
    public $ItemizedCharges;
    /**
     * The NegotiatedCharges
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesNegotiatedChargesType
     */
    public $NegotiatedCharges;
    /**
     * Constructor method for RatedPackageType
     * @uses Ups_ratesRatedPackageType::setTransportationCharges()
     * @uses Ups_ratesRatedPackageType::setBaseServiceCharge()
     * @uses Ups_ratesRatedPackageType::setServiceOptionsCharges()
     * @uses Ups_ratesRatedPackageType::setTotalCharges()
     * @uses Ups_ratesRatedPackageType::setWeight()
     * @uses Ups_ratesRatedPackageType::setBillingWeight()
     * @uses Ups_ratesRatedPackageType::setAccessorial()
     * @uses Ups_ratesRatedPackageType::setItemizedCharges()
     * @uses Ups_ratesRatedPackageType::setNegotiatedCharges()
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $transportationCharges
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $baseServiceCharge
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $serviceOptionsCharges
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $totalCharges
     * @param string $weight
     * @param \Ups_rates\UPSratesStruct\Ups_ratesBillingWeightType $billingWeight
     * @param \Ups_rates\UPSratesStruct\Ups_ratesAccessorialType[] $accessorial
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType[] $itemizedCharges
     * @param \Ups_rates\UPSratesStruct\Ups_ratesNegotiatedChargesType $negotiatedCharges
     */
    public function __construct(\Ups_rates\UPSratesStruct\Ups_ratesChargesType $transportationCharges = null, \Ups_rates\UPSratesStruct\Ups_ratesChargesType $baseServiceCharge = null, \Ups_rates\UPSratesStruct\Ups_ratesChargesType $serviceOptionsCharges = null, \Ups_rates\UPSratesStruct\Ups_ratesChargesType $totalCharges = null, $weight = null, \Ups_rates\UPSratesStruct\Ups_ratesBillingWeightType $billingWeight = null, array $accessorial = array(), array $itemizedCharges = array(), \Ups_rates\UPSratesStruct\Ups_ratesNegotiatedChargesType $negotiatedCharges = null)
    {
        $this
            ->setTransportationCharges($transportationCharges)
            ->setBaseServiceCharge($baseServiceCharge)
            ->setServiceOptionsCharges($serviceOptionsCharges)
            ->setTotalCharges($totalCharges)
            ->setWeight($weight)
            ->setBillingWeight($billingWeight)
            ->setAccessorial($accessorial)
            ->setItemizedCharges($itemizedCharges)
            ->setNegotiatedCharges($negotiatedCharges);
    }
    /**
     * Get TransportationCharges value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesChargesType|null
     */
    public function getTransportationCharges()
    {
        return $this->TransportationCharges;
    }
    /**
     * Set TransportationCharges value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $transportationCharges
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRatedPackageType
     */
    public function setTransportationCharges(\Ups_rates\UPSratesStruct\Ups_ratesChargesType $transportationCharges = null)
    {
        $this->TransportationCharges = $transportationCharges;
        return $this;
    }
    /**
     * Get BaseServiceCharge value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesChargesType|null
     */
    public function getBaseServiceCharge()
    {
        return $this->BaseServiceCharge;
    }
    /**
     * Set BaseServiceCharge value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $baseServiceCharge
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRatedPackageType
     */
    public function setBaseServiceCharge(\Ups_rates\UPSratesStruct\Ups_ratesChargesType $baseServiceCharge = null)
    {
        $this->BaseServiceCharge = $baseServiceCharge;
        return $this;
    }
    /**
     * Get ServiceOptionsCharges value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesChargesType|null
     */
    public function getServiceOptionsCharges()
    {
        return $this->ServiceOptionsCharges;
    }
    /**
     * Set ServiceOptionsCharges value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $serviceOptionsCharges
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRatedPackageType
     */
    public function setServiceOptionsCharges(\Ups_rates\UPSratesStruct\Ups_ratesChargesType $serviceOptionsCharges = null)
    {
        $this->ServiceOptionsCharges = $serviceOptionsCharges;
        return $this;
    }
    /**
     * Get TotalCharges value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesChargesType|null
     */
    public function getTotalCharges()
    {
        return $this->TotalCharges;
    }
    /**
     * Set TotalCharges value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $totalCharges
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRatedPackageType
     */
    public function setTotalCharges(\Ups_rates\UPSratesStruct\Ups_ratesChargesType $totalCharges = null)
    {
        $this->TotalCharges = $totalCharges;
        return $this;
    }
    /**
     * Get Weight value
     * @return string|null
     */
    public function getWeight()
    {
        return $this->Weight;
    }
    /**
     * Set Weight value
     * @param string $weight
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRatedPackageType
     */
    public function setWeight($weight = null)
    {
        // validation for constraint: string
        if (!is_null($weight) && !is_string($weight)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($weight, true), gettype($weight)), __LINE__);
        }
        $this->Weight = $weight;
        return $this;
    }
    /**
     * Get BillingWeight value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesBillingWeightType|null
     */
    public function getBillingWeight()
    {
        return $this->BillingWeight;
    }
    /**
     * Set BillingWeight value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesBillingWeightType $billingWeight
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRatedPackageType
     */
    public function setBillingWeight(\Ups_rates\UPSratesStruct\Ups_ratesBillingWeightType $billingWeight = null)
    {
        $this->BillingWeight = $billingWeight;
        return $this;
    }
    /**
     * Get Accessorial value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesAccessorialType[]|null
     */
    public function getAccessorial()
    {
        return $this->Accessorial;
    }
    /**
     * This method is responsible for validating the values passed to the setAccessorial method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAccessorial method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAccessorialForArrayConstraintsFromSetAccessorial(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $ratedPackageTypeAccessorialItem) {
            // validation for constraint: itemType
            if (!$ratedPackageTypeAccessorialItem instanceof \Ups_rates\UPSratesStruct\Ups_ratesAccessorialType) {
                $invalidValues[] = is_object($ratedPackageTypeAccessorialItem) ? get_class($ratedPackageTypeAccessorialItem) : sprintf('%s(%s)', gettype($ratedPackageTypeAccessorialItem), var_export($ratedPackageTypeAccessorialItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Accessorial property can only contain items of type \Ups_rates\UPSratesStruct\Ups_ratesAccessorialType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Accessorial value
     * @throws \InvalidArgumentException
     * @param \Ups_rates\UPSratesStruct\Ups_ratesAccessorialType[] $accessorial
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRatedPackageType
     */
    public function setAccessorial(array $accessorial = array())
    {
        // validation for constraint: array
        if ('' !== ($accessorialArrayErrorMessage = self::validateAccessorialForArrayConstraintsFromSetAccessorial($accessorial))) {
            throw new \InvalidArgumentException($accessorialArrayErrorMessage, __LINE__);
        }
        $this->Accessorial = $accessorial;
        return $this;
    }
    /**
     * Add item to Accessorial value
     * @throws \InvalidArgumentException
     * @param \Ups_rates\UPSratesStruct\Ups_ratesAccessorialType $item
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRatedPackageType
     */
    public function addToAccessorial(\Ups_rates\UPSratesStruct\Ups_ratesAccessorialType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_rates\UPSratesStruct\Ups_ratesAccessorialType) {
            throw new \InvalidArgumentException(sprintf('The Accessorial property can only contain items of type \Ups_rates\UPSratesStruct\Ups_ratesAccessorialType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Accessorial[] = $item;
        return $this;
    }
    /**
     * Get ItemizedCharges value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesChargesType[]|null
     */
    public function getItemizedCharges()
    {
        return $this->ItemizedCharges;
    }
    /**
     * This method is responsible for validating the values passed to the setItemizedCharges method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItemizedCharges method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItemizedChargesForArrayConstraintsFromSetItemizedCharges(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $ratedPackageTypeItemizedChargesItem) {
            // validation for constraint: itemType
            if (!$ratedPackageTypeItemizedChargesItem instanceof \Ups_rates\UPSratesStruct\Ups_ratesChargesType) {
                $invalidValues[] = is_object($ratedPackageTypeItemizedChargesItem) ? get_class($ratedPackageTypeItemizedChargesItem) : sprintf('%s(%s)', gettype($ratedPackageTypeItemizedChargesItem), var_export($ratedPackageTypeItemizedChargesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ItemizedCharges property can only contain items of type \Ups_rates\UPSratesStruct\Ups_ratesChargesType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ItemizedCharges value
     * @throws \InvalidArgumentException
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType[] $itemizedCharges
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRatedPackageType
     */
    public function setItemizedCharges(array $itemizedCharges = array())
    {
        // validation for constraint: array
        if ('' !== ($itemizedChargesArrayErrorMessage = self::validateItemizedChargesForArrayConstraintsFromSetItemizedCharges($itemizedCharges))) {
            throw new \InvalidArgumentException($itemizedChargesArrayErrorMessage, __LINE__);
        }
        $this->ItemizedCharges = $itemizedCharges;
        return $this;
    }
    /**
     * Add item to ItemizedCharges value
     * @throws \InvalidArgumentException
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $item
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRatedPackageType
     */
    public function addToItemizedCharges(\Ups_rates\UPSratesStruct\Ups_ratesChargesType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_rates\UPSratesStruct\Ups_ratesChargesType) {
            throw new \InvalidArgumentException(sprintf('The ItemizedCharges property can only contain items of type \Ups_rates\UPSratesStruct\Ups_ratesChargesType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ItemizedCharges[] = $item;
        return $this;
    }
    /**
     * Get NegotiatedCharges value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesNegotiatedChargesType|null
     */
    public function getNegotiatedCharges()
    {
        return $this->NegotiatedCharges;
    }
    /**
     * Set NegotiatedCharges value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesNegotiatedChargesType $negotiatedCharges
     * @return \Ups_rates\UPSratesStruct\Ups_ratesRatedPackageType
     */
    public function setNegotiatedCharges(\Ups_rates\UPSratesStruct\Ups_ratesNegotiatedChargesType $negotiatedCharges = null)
    {
        $this->NegotiatedCharges = $negotiatedCharges;
        return $this;
    }
}
