<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceSummaryType UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesServiceSummaryType extends AbstractStructBase
{
    /**
     * The Service
     * @var \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType
     */
    public $Service;
    /**
     * The EstimatedArrival
     * @var \Ups_rates\UPSratesStruct\Ups_ratesEstimatedArrivalType
     */
    public $EstimatedArrival;
    /**
     * The GuaranteedIndicator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $GuaranteedIndicator;
    /**
     * The Disclaimer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Disclaimer;
    /**
     * The SaturdayDelivery
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $SaturdayDelivery;
    /**
     * The SaturdayDeliveryDisclaimer
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $SaturdayDeliveryDisclaimer;
    /**
     * Constructor method for ServiceSummaryType
     * @uses Ups_ratesServiceSummaryType::setService()
     * @uses Ups_ratesServiceSummaryType::setEstimatedArrival()
     * @uses Ups_ratesServiceSummaryType::setGuaranteedIndicator()
     * @uses Ups_ratesServiceSummaryType::setDisclaimer()
     * @uses Ups_ratesServiceSummaryType::setSaturdayDelivery()
     * @uses Ups_ratesServiceSummaryType::setSaturdayDeliveryDisclaimer()
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $service
     * @param \Ups_rates\UPSratesStruct\Ups_ratesEstimatedArrivalType $estimatedArrival
     * @param string $guaranteedIndicator
     * @param string $disclaimer
     * @param string $saturdayDelivery
     * @param string $saturdayDeliveryDisclaimer
     */
    public function __construct(\Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $service = null, \Ups_rates\UPSratesStruct\Ups_ratesEstimatedArrivalType $estimatedArrival = null, $guaranteedIndicator = null, $disclaimer = null, $saturdayDelivery = null, $saturdayDeliveryDisclaimer = null)
    {
        $this
            ->setService($service)
            ->setEstimatedArrival($estimatedArrival)
            ->setGuaranteedIndicator($guaranteedIndicator)
            ->setDisclaimer($disclaimer)
            ->setSaturdayDelivery($saturdayDelivery)
            ->setSaturdayDeliveryDisclaimer($saturdayDeliveryDisclaimer);
    }
    /**
     * Get Service value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType|null
     */
    public function getService()
    {
        return $this->Service;
    }
    /**
     * Set Service value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $service
     * @return \Ups_rates\UPSratesStruct\Ups_ratesServiceSummaryType
     */
    public function setService(\Ups_rates\UPSratesStruct\Ups_ratesCodeDescriptionType $service = null)
    {
        $this->Service = $service;
        return $this;
    }
    /**
     * Get EstimatedArrival value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesEstimatedArrivalType|null
     */
    public function getEstimatedArrival()
    {
        return $this->EstimatedArrival;
    }
    /**
     * Set EstimatedArrival value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesEstimatedArrivalType $estimatedArrival
     * @return \Ups_rates\UPSratesStruct\Ups_ratesServiceSummaryType
     */
    public function setEstimatedArrival(\Ups_rates\UPSratesStruct\Ups_ratesEstimatedArrivalType $estimatedArrival = null)
    {
        $this->EstimatedArrival = $estimatedArrival;
        return $this;
    }
    /**
     * Get GuaranteedIndicator value
     * @return string|null
     */
    public function getGuaranteedIndicator()
    {
        return $this->GuaranteedIndicator;
    }
    /**
     * Set GuaranteedIndicator value
     * @param string $guaranteedIndicator
     * @return \Ups_rates\UPSratesStruct\Ups_ratesServiceSummaryType
     */
    public function setGuaranteedIndicator($guaranteedIndicator = null)
    {
        // validation for constraint: string
        if (!is_null($guaranteedIndicator) && !is_string($guaranteedIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($guaranteedIndicator, true), gettype($guaranteedIndicator)), __LINE__);
        }
        $this->GuaranteedIndicator = $guaranteedIndicator;
        return $this;
    }
    /**
     * Get Disclaimer value
     * @return string|null
     */
    public function getDisclaimer()
    {
        return $this->Disclaimer;
    }
    /**
     * Set Disclaimer value
     * @param string $disclaimer
     * @return \Ups_rates\UPSratesStruct\Ups_ratesServiceSummaryType
     */
    public function setDisclaimer($disclaimer = null)
    {
        // validation for constraint: string
        if (!is_null($disclaimer) && !is_string($disclaimer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($disclaimer, true), gettype($disclaimer)), __LINE__);
        }
        $this->Disclaimer = $disclaimer;
        return $this;
    }
    /**
     * Get SaturdayDelivery value
     * @return string|null
     */
    public function getSaturdayDelivery()
    {
        return $this->SaturdayDelivery;
    }
    /**
     * Set SaturdayDelivery value
     * @param string $saturdayDelivery
     * @return \Ups_rates\UPSratesStruct\Ups_ratesServiceSummaryType
     */
    public function setSaturdayDelivery($saturdayDelivery = null)
    {
        // validation for constraint: string
        if (!is_null($saturdayDelivery) && !is_string($saturdayDelivery)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($saturdayDelivery, true), gettype($saturdayDelivery)), __LINE__);
        }
        $this->SaturdayDelivery = $saturdayDelivery;
        return $this;
    }
    /**
     * Get SaturdayDeliveryDisclaimer value
     * @return string|null
     */
    public function getSaturdayDeliveryDisclaimer()
    {
        return $this->SaturdayDeliveryDisclaimer;
    }
    /**
     * Set SaturdayDeliveryDisclaimer value
     * @param string $saturdayDeliveryDisclaimer
     * @return \Ups_rates\UPSratesStruct\Ups_ratesServiceSummaryType
     */
    public function setSaturdayDeliveryDisclaimer($saturdayDeliveryDisclaimer = null)
    {
        // validation for constraint: string
        if (!is_null($saturdayDeliveryDisclaimer) && !is_string($saturdayDeliveryDisclaimer)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($saturdayDeliveryDisclaimer, true), gettype($saturdayDeliveryDisclaimer)), __LINE__);
        }
        $this->SaturdayDeliveryDisclaimer = $saturdayDeliveryDisclaimer;
        return $this;
    }
}
