<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipFromType UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesShipFromType extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The AttentionName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AttentionName;
    /**
     * The Address
     * @var \Ups_rates\UPSratesStruct\Ups_ratesShipAddressType
     */
    public $Address;
    /**
     * Constructor method for ShipFromType
     * @uses Ups_ratesShipFromType::setName()
     * @uses Ups_ratesShipFromType::setAttentionName()
     * @uses Ups_ratesShipFromType::setAddress()
     * @param string $name
     * @param string $attentionName
     * @param \Ups_rates\UPSratesStruct\Ups_ratesShipAddressType $address
     */
    public function __construct($name = null, $attentionName = null, \Ups_rates\UPSratesStruct\Ups_ratesShipAddressType $address = null)
    {
        $this
            ->setName($name)
            ->setAttentionName($attentionName)
            ->setAddress($address);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipFromType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get AttentionName value
     * @return string|null
     */
    public function getAttentionName()
    {
        return $this->AttentionName;
    }
    /**
     * Set AttentionName value
     * @param string $attentionName
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipFromType
     */
    public function setAttentionName($attentionName = null)
    {
        // validation for constraint: string
        if (!is_null($attentionName) && !is_string($attentionName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($attentionName, true), gettype($attentionName)), __LINE__);
        }
        $this->AttentionName = $attentionName;
        return $this;
    }
    /**
     * Get Address value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipAddressType|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesShipAddressType $address
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipFromType
     */
    public function setAddress(\Ups_rates\UPSratesStruct\Ups_ratesShipAddressType $address = null)
    {
        $this->Address = $address;
        return $this;
    }
}
