<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipmentChargeType UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesShipmentChargeType extends AbstractStructBase
{
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * The BillShipper
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesBillShipperChargeType
     */
    public $BillShipper;
    /**
     * The BillReceiver
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesBillReceiverChargeType
     */
    public $BillReceiver;
    /**
     * The BillThirdParty
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesBillThirdPartyChargeType
     */
    public $BillThirdParty;
    /**
     * The ConsigneeBilledIndicator
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ConsigneeBilledIndicator;
    /**
     * Constructor method for ShipmentChargeType
     * @uses Ups_ratesShipmentChargeType::setType()
     * @uses Ups_ratesShipmentChargeType::setBillShipper()
     * @uses Ups_ratesShipmentChargeType::setBillReceiver()
     * @uses Ups_ratesShipmentChargeType::setBillThirdParty()
     * @uses Ups_ratesShipmentChargeType::setConsigneeBilledIndicator()
     * @param string $type
     * @param \Ups_rates\UPSratesStruct\Ups_ratesBillShipperChargeType $billShipper
     * @param \Ups_rates\UPSratesStruct\Ups_ratesBillReceiverChargeType $billReceiver
     * @param \Ups_rates\UPSratesStruct\Ups_ratesBillThirdPartyChargeType $billThirdParty
     * @param string $consigneeBilledIndicator
     */
    public function __construct($type = null, \Ups_rates\UPSratesStruct\Ups_ratesBillShipperChargeType $billShipper = null, \Ups_rates\UPSratesStruct\Ups_ratesBillReceiverChargeType $billReceiver = null, \Ups_rates\UPSratesStruct\Ups_ratesBillThirdPartyChargeType $billThirdParty = null, $consigneeBilledIndicator = null)
    {
        $this
            ->setType($type)
            ->setBillShipper($billShipper)
            ->setBillReceiver($billReceiver)
            ->setBillThirdParty($billThirdParty)
            ->setConsigneeBilledIndicator($consigneeBilledIndicator);
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipmentChargeType
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($type, true), gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get BillShipper value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesBillShipperChargeType|null
     */
    public function getBillShipper()
    {
        return $this->BillShipper;
    }
    /**
     * Set BillShipper value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesBillShipperChargeType $billShipper
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipmentChargeType
     */
    public function setBillShipper(\Ups_rates\UPSratesStruct\Ups_ratesBillShipperChargeType $billShipper = null)
    {
        $this->BillShipper = $billShipper;
        return $this;
    }
    /**
     * Get BillReceiver value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesBillReceiverChargeType|null
     */
    public function getBillReceiver()
    {
        return $this->BillReceiver;
    }
    /**
     * Set BillReceiver value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesBillReceiverChargeType $billReceiver
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipmentChargeType
     */
    public function setBillReceiver(\Ups_rates\UPSratesStruct\Ups_ratesBillReceiverChargeType $billReceiver = null)
    {
        $this->BillReceiver = $billReceiver;
        return $this;
    }
    /**
     * Get BillThirdParty value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesBillThirdPartyChargeType|null
     */
    public function getBillThirdParty()
    {
        return $this->BillThirdParty;
    }
    /**
     * Set BillThirdParty value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesBillThirdPartyChargeType $billThirdParty
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipmentChargeType
     */
    public function setBillThirdParty(\Ups_rates\UPSratesStruct\Ups_ratesBillThirdPartyChargeType $billThirdParty = null)
    {
        $this->BillThirdParty = $billThirdParty;
        return $this;
    }
    /**
     * Get ConsigneeBilledIndicator value
     * @return string|null
     */
    public function getConsigneeBilledIndicator()
    {
        return $this->ConsigneeBilledIndicator;
    }
    /**
     * Set ConsigneeBilledIndicator value
     * @param string $consigneeBilledIndicator
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipmentChargeType
     */
    public function setConsigneeBilledIndicator($consigneeBilledIndicator = null)
    {
        // validation for constraint: string
        if (!is_null($consigneeBilledIndicator) && !is_string($consigneeBilledIndicator)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($consigneeBilledIndicator, true), gettype($consigneeBilledIndicator)), __LINE__);
        }
        $this->ConsigneeBilledIndicator = $consigneeBilledIndicator;
        return $this;
    }
}
