<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ShipperType UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesShipperType extends AbstractStructBase
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The AttentionName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $AttentionName;
    /**
     * The ShipperNumber
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $ShipperNumber;
    /**
     * The Address
     * @var \Ups_rates\UPSratesStruct\Ups_ratesAddressType
     */
    public $Address;
    /**
     * Constructor method for ShipperType
     * @uses Ups_ratesShipperType::setName()
     * @uses Ups_ratesShipperType::setAttentionName()
     * @uses Ups_ratesShipperType::setShipperNumber()
     * @uses Ups_ratesShipperType::setAddress()
     * @param string $name
     * @param string $attentionName
     * @param string $shipperNumber
     * @param \Ups_rates\UPSratesStruct\Ups_ratesAddressType $address
     */
    public function __construct($name = null, $attentionName = null, $shipperNumber = null, \Ups_rates\UPSratesStruct\Ups_ratesAddressType $address = null)
    {
        $this
            ->setName($name)
            ->setAttentionName($attentionName)
            ->setShipperNumber($shipperNumber)
            ->setAddress($address);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipperType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get AttentionName value
     * @return string|null
     */
    public function getAttentionName()
    {
        return $this->AttentionName;
    }
    /**
     * Set AttentionName value
     * @param string $attentionName
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipperType
     */
    public function setAttentionName($attentionName = null)
    {
        // validation for constraint: string
        if (!is_null($attentionName) && !is_string($attentionName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($attentionName, true), gettype($attentionName)), __LINE__);
        }
        $this->AttentionName = $attentionName;
        return $this;
    }
    /**
     * Get ShipperNumber value
     * @return string|null
     */
    public function getShipperNumber()
    {
        return $this->ShipperNumber;
    }
    /**
     * Set ShipperNumber value
     * @param string $shipperNumber
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipperType
     */
    public function setShipperNumber($shipperNumber = null)
    {
        // validation for constraint: string
        if (!is_null($shipperNumber) && !is_string($shipperNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($shipperNumber, true), gettype($shipperNumber)), __LINE__);
        }
        $this->ShipperNumber = $shipperNumber;
        return $this;
    }
    /**
     * Get Address value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesAddressType|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesAddressType $address
     * @return \Ups_rates\UPSratesStruct\Ups_ratesShipperType
     */
    public function setAddress(\Ups_rates\UPSratesStruct\Ups_ratesAddressType $address = null)
    {
        $this->Address = $address;
        return $this;
    }
}
