<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TimeInTransitRequestType UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesTimeInTransitRequestType extends AbstractStructBase
{
    /**
     * The PackageBillType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $PackageBillType;
    /**
     * The Pickup
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesPickupType
     */
    public $Pickup;
    /**
     * The ReturnContractServices
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesReturnContractServicesType[]
     */
    public $ReturnContractServices;
    /**
     * Constructor method for TimeInTransitRequestType
     * @uses Ups_ratesTimeInTransitRequestType::setPackageBillType()
     * @uses Ups_ratesTimeInTransitRequestType::setPickup()
     * @uses Ups_ratesTimeInTransitRequestType::setReturnContractServices()
     * @param string $packageBillType
     * @param \Ups_rates\UPSratesStruct\Ups_ratesPickupType $pickup
     * @param \Ups_rates\UPSratesStruct\Ups_ratesReturnContractServicesType[] $returnContractServices
     */
    public function __construct($packageBillType = null, \Ups_rates\UPSratesStruct\Ups_ratesPickupType $pickup = null, array $returnContractServices = array())
    {
        $this
            ->setPackageBillType($packageBillType)
            ->setPickup($pickup)
            ->setReturnContractServices($returnContractServices);
    }
    /**
     * Get PackageBillType value
     * @return string|null
     */
    public function getPackageBillType()
    {
        return $this->PackageBillType;
    }
    /**
     * Set PackageBillType value
     * @param string $packageBillType
     * @return \Ups_rates\UPSratesStruct\Ups_ratesTimeInTransitRequestType
     */
    public function setPackageBillType($packageBillType = null)
    {
        // validation for constraint: string
        if (!is_null($packageBillType) && !is_string($packageBillType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($packageBillType, true), gettype($packageBillType)), __LINE__);
        }
        $this->PackageBillType = $packageBillType;
        return $this;
    }
    /**
     * Get Pickup value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesPickupType|null
     */
    public function getPickup()
    {
        return $this->Pickup;
    }
    /**
     * Set Pickup value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesPickupType $pickup
     * @return \Ups_rates\UPSratesStruct\Ups_ratesTimeInTransitRequestType
     */
    public function setPickup(\Ups_rates\UPSratesStruct\Ups_ratesPickupType $pickup = null)
    {
        $this->Pickup = $pickup;
        return $this;
    }
    /**
     * Get ReturnContractServices value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesReturnContractServicesType[]|null
     */
    public function getReturnContractServices()
    {
        return $this->ReturnContractServices;
    }
    /**
     * This method is responsible for validating the values passed to the setReturnContractServices method
     * This method is willingly generated in order to preserve the one-line inline validation within the setReturnContractServices method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateReturnContractServicesForArrayConstraintsFromSetReturnContractServices(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $timeInTransitRequestTypeReturnContractServicesItem) {
            // validation for constraint: itemType
            if (!$timeInTransitRequestTypeReturnContractServicesItem instanceof \Ups_rates\UPSratesStruct\Ups_ratesReturnContractServicesType) {
                $invalidValues[] = is_object($timeInTransitRequestTypeReturnContractServicesItem) ? get_class($timeInTransitRequestTypeReturnContractServicesItem) : sprintf('%s(%s)', gettype($timeInTransitRequestTypeReturnContractServicesItem), var_export($timeInTransitRequestTypeReturnContractServicesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ReturnContractServices property can only contain items of type \Ups_rates\UPSratesStruct\Ups_ratesReturnContractServicesType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ReturnContractServices value
     * @throws \InvalidArgumentException
     * @param \Ups_rates\UPSratesStruct\Ups_ratesReturnContractServicesType[] $returnContractServices
     * @return \Ups_rates\UPSratesStruct\Ups_ratesTimeInTransitRequestType
     */
    public function setReturnContractServices(array $returnContractServices = array())
    {
        // validation for constraint: array
        if ('' !== ($returnContractServicesArrayErrorMessage = self::validateReturnContractServicesForArrayConstraintsFromSetReturnContractServices($returnContractServices))) {
            throw new \InvalidArgumentException($returnContractServicesArrayErrorMessage, __LINE__);
        }
        $this->ReturnContractServices = $returnContractServices;
        return $this;
    }
    /**
     * Add item to ReturnContractServices value
     * @throws \InvalidArgumentException
     * @param \Ups_rates\UPSratesStruct\Ups_ratesReturnContractServicesType $item
     * @return \Ups_rates\UPSratesStruct\Ups_ratesTimeInTransitRequestType
     */
    public function addToReturnContractServices(\Ups_rates\UPSratesStruct\Ups_ratesReturnContractServicesType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_rates\UPSratesStruct\Ups_ratesReturnContractServicesType) {
            throw new \InvalidArgumentException(sprintf('The ReturnContractServices property can only contain items of type \Ups_rates\UPSratesStruct\Ups_ratesReturnContractServicesType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ReturnContractServices[] = $item;
        return $this;
    }
}
