<?php

namespace Ups_rates\UPSratesStruct;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for TotalChargeType UPSratesStruct
 * @package Ups_rates
 * @subpackage Structs
 */
class Ups_ratesTotalChargeType extends AbstractStructBase
{
    /**
     * The ItemizedCharges
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesChargesType[]
     */
    public $ItemizedCharges;
    /**
     * The TaxCharges
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesTaxChargeType[]
     */
    public $TaxCharges;
    /**
     * The TotalCharge
     * @var \Ups_rates\UPSratesStruct\Ups_ratesChargesType
     */
    public $TotalCharge;
    /**
     * The TotalChargesWithTaxes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Ups_rates\UPSratesStruct\Ups_ratesChargesType
     */
    public $TotalChargesWithTaxes;
    /**
     * Constructor method for TotalChargeType
     * @uses Ups_ratesTotalChargeType::setItemizedCharges()
     * @uses Ups_ratesTotalChargeType::setTaxCharges()
     * @uses Ups_ratesTotalChargeType::setTotalCharge()
     * @uses Ups_ratesTotalChargeType::setTotalChargesWithTaxes()
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType[] $itemizedCharges
     * @param \Ups_rates\UPSratesStruct\Ups_ratesTaxChargeType[] $taxCharges
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $totalCharge
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $totalChargesWithTaxes
     */
    public function __construct(array $itemizedCharges = array(), array $taxCharges = array(), \Ups_rates\UPSratesStruct\Ups_ratesChargesType $totalCharge = null, \Ups_rates\UPSratesStruct\Ups_ratesChargesType $totalChargesWithTaxes = null)
    {
        $this
            ->setItemizedCharges($itemizedCharges)
            ->setTaxCharges($taxCharges)
            ->setTotalCharge($totalCharge)
            ->setTotalChargesWithTaxes($totalChargesWithTaxes);
    }
    /**
     * Get ItemizedCharges value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesChargesType[]|null
     */
    public function getItemizedCharges()
    {
        return $this->ItemizedCharges;
    }
    /**
     * This method is responsible for validating the values passed to the setItemizedCharges method
     * This method is willingly generated in order to preserve the one-line inline validation within the setItemizedCharges method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateItemizedChargesForArrayConstraintsFromSetItemizedCharges(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $totalChargeTypeItemizedChargesItem) {
            // validation for constraint: itemType
            if (!$totalChargeTypeItemizedChargesItem instanceof \Ups_rates\UPSratesStruct\Ups_ratesChargesType) {
                $invalidValues[] = is_object($totalChargeTypeItemizedChargesItem) ? get_class($totalChargeTypeItemizedChargesItem) : sprintf('%s(%s)', gettype($totalChargeTypeItemizedChargesItem), var_export($totalChargeTypeItemizedChargesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ItemizedCharges property can only contain items of type \Ups_rates\UPSratesStruct\Ups_ratesChargesType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ItemizedCharges value
     * @throws \InvalidArgumentException
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType[] $itemizedCharges
     * @return \Ups_rates\UPSratesStruct\Ups_ratesTotalChargeType
     */
    public function setItemizedCharges(array $itemizedCharges = array())
    {
        // validation for constraint: array
        if ('' !== ($itemizedChargesArrayErrorMessage = self::validateItemizedChargesForArrayConstraintsFromSetItemizedCharges($itemizedCharges))) {
            throw new \InvalidArgumentException($itemizedChargesArrayErrorMessage, __LINE__);
        }
        $this->ItemizedCharges = $itemizedCharges;
        return $this;
    }
    /**
     * Add item to ItemizedCharges value
     * @throws \InvalidArgumentException
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $item
     * @return \Ups_rates\UPSratesStruct\Ups_ratesTotalChargeType
     */
    public function addToItemizedCharges(\Ups_rates\UPSratesStruct\Ups_ratesChargesType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_rates\UPSratesStruct\Ups_ratesChargesType) {
            throw new \InvalidArgumentException(sprintf('The ItemizedCharges property can only contain items of type \Ups_rates\UPSratesStruct\Ups_ratesChargesType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ItemizedCharges[] = $item;
        return $this;
    }
    /**
     * Get TaxCharges value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesTaxChargeType[]|null
     */
    public function getTaxCharges()
    {
        return $this->TaxCharges;
    }
    /**
     * This method is responsible for validating the values passed to the setTaxCharges method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTaxCharges method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTaxChargesForArrayConstraintsFromSetTaxCharges(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $totalChargeTypeTaxChargesItem) {
            // validation for constraint: itemType
            if (!$totalChargeTypeTaxChargesItem instanceof \Ups_rates\UPSratesStruct\Ups_ratesTaxChargeType) {
                $invalidValues[] = is_object($totalChargeTypeTaxChargesItem) ? get_class($totalChargeTypeTaxChargesItem) : sprintf('%s(%s)', gettype($totalChargeTypeTaxChargesItem), var_export($totalChargeTypeTaxChargesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TaxCharges property can only contain items of type \Ups_rates\UPSratesStruct\Ups_ratesTaxChargeType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TaxCharges value
     * @throws \InvalidArgumentException
     * @param \Ups_rates\UPSratesStruct\Ups_ratesTaxChargeType[] $taxCharges
     * @return \Ups_rates\UPSratesStruct\Ups_ratesTotalChargeType
     */
    public function setTaxCharges(array $taxCharges = array())
    {
        // validation for constraint: array
        if ('' !== ($taxChargesArrayErrorMessage = self::validateTaxChargesForArrayConstraintsFromSetTaxCharges($taxCharges))) {
            throw new \InvalidArgumentException($taxChargesArrayErrorMessage, __LINE__);
        }
        $this->TaxCharges = $taxCharges;
        return $this;
    }
    /**
     * Add item to TaxCharges value
     * @throws \InvalidArgumentException
     * @param \Ups_rates\UPSratesStruct\Ups_ratesTaxChargeType $item
     * @return \Ups_rates\UPSratesStruct\Ups_ratesTotalChargeType
     */
    public function addToTaxCharges(\Ups_rates\UPSratesStruct\Ups_ratesTaxChargeType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Ups_rates\UPSratesStruct\Ups_ratesTaxChargeType) {
            throw new \InvalidArgumentException(sprintf('The TaxCharges property can only contain items of type \Ups_rates\UPSratesStruct\Ups_ratesTaxChargeType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TaxCharges[] = $item;
        return $this;
    }
    /**
     * Get TotalCharge value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesChargesType|null
     */
    public function getTotalCharge()
    {
        return $this->TotalCharge;
    }
    /**
     * Set TotalCharge value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $totalCharge
     * @return \Ups_rates\UPSratesStruct\Ups_ratesTotalChargeType
     */
    public function setTotalCharge(\Ups_rates\UPSratesStruct\Ups_ratesChargesType $totalCharge = null)
    {
        $this->TotalCharge = $totalCharge;
        return $this;
    }
    /**
     * Get TotalChargesWithTaxes value
     * @return \Ups_rates\UPSratesStruct\Ups_ratesChargesType|null
     */
    public function getTotalChargesWithTaxes()
    {
        return $this->TotalChargesWithTaxes;
    }
    /**
     * Set TotalChargesWithTaxes value
     * @param \Ups_rates\UPSratesStruct\Ups_ratesChargesType $totalChargesWithTaxes
     * @return \Ups_rates\UPSratesStruct\Ups_ratesTotalChargeType
     */
    public function setTotalChargesWithTaxes(\Ups_rates\UPSratesStruct\Ups_ratesChargesType $totalChargesWithTaxes = null)
    {
        $this->TotalChargesWithTaxes = $totalChargesWithTaxes;
        return $this;
    }
}
