<?php

namespace Ups_rates;

/**
 * Class which returns the class map definition
 * @package Ups_rates
 */
class Ups_ratesClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'UPSSecurity' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesUPSSecurity',
            'UsernameToken' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesUsernameToken',
            'ServiceAccessToken' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesServiceAccessToken',
            'Errors' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesErrors',
            'ErrorDetailType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesErrorDetailType',
            'ElementLevelInformationType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesElementLevelInformationType',
            'ElementIdentifierType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesElementIdentifierType',
            'CodeType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesCodeType',
            'AdditionalInfoType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesAdditionalInfoType',
            'AdditionalCodeDescType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesAdditionalCodeDescType',
            'LocationType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesLocationType',
            'ClientInformationType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesClientInformationType',
            'Property' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesProperty',
            'RequestType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesRequestType',
            'TransactionReferenceType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesTransactionReferenceType',
            'ResponseType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesResponseType',
            'CodeDescriptionType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesCodeDescriptionType',
            'DetailType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesDetailType',
            'RateRequest' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesRateRequest',
            'RateResponse' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesRateResponse',
            'BillingWeightType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesBillingWeightType',
            'RatedPackageType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesRatedPackageType',
            'AccessorialType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesAccessorialType',
            'NegotiatedChargesType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesNegotiatedChargesType',
            'RatedShipmentType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesRatedShipmentType',
            'ReturnContractServicesType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesReturnContractServicesType',
            'TimeInTransitResponseType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesTimeInTransitResponseType',
            'ServiceSummaryType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesServiceSummaryType',
            'EstimatedArrivalType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesEstimatedArrivalType',
            'DisclaimerType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesDisclaimerType',
            'TaxChargeType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesTaxChargeType',
            'TotalChargeType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesTotalChargeType',
            'RatedShipmentInfoType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesRatedShipmentInfoType',
            'ChargesType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesChargesType',
            'TransportationChargesType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesTransportationChargesType',
            'FRSShipmentType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesFRSShipmentType',
            'FreightDensityRateType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesFreightDensityRateType',
            'HandlingUnitsResponseType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesHandlingUnitsResponseType',
            'AddressType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesAddressType',
            'ShipToAddressType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesShipToAddressType',
            'ShipAddressType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesShipAddressType',
            'CODType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesCODType',
            'CODAmountType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesCODAmountType',
            'DeliveryConfirmationType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesDeliveryConfirmationType',
            'DimensionsType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesDimensionsType',
            'InsuredValueType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesInsuredValueType',
            'PackageType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesPackageType',
            'CommodityType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesCommodityType',
            'NMFCCommodityType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesNMFCCommodityType',
            'PackageServiceOptionsType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesPackageServiceOptionsType',
            'UPSPremierType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesUPSPremierType',
            'HazMatType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesHazMatType',
            'HazMatChemicalRecordType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesHazMatChemicalRecordType',
            'PackageServiceOptionsAccessPointCODType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesPackageServiceOptionsAccessPointCODType',
            'DryIceType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesDryIceType',
            'DryIceWeightType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesDryIceWeightType',
            'ShipperDeclaredValueType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesShipperDeclaredValueType',
            'InsuranceType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesInsuranceType',
            'InsuranceValueType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesInsuranceValueType',
            'PackageWeightType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesPackageWeightType',
            'UOMCodeDescriptionType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesUOMCodeDescriptionType',
            'ShipmentRatingOptionsType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesShipmentRatingOptionsType',
            'ShipFromType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesShipFromType',
            'ShipToType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesShipToType',
            'ShipmentType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesShipmentType',
            'TimeInTransitRequestType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesTimeInTransitRequestType',
            'PickupType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesPickupType',
            'PromotionalDiscountInformationType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesPromotionalDiscountInformationType',
            'ShipmentWeightType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesShipmentWeightType',
            'PaymentDetailsType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesPaymentDetailsType',
            'ShipmentChargeType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesShipmentChargeType',
            'BillShipperChargeType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesBillShipperChargeType',
            'BillReceiverChargeType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesBillReceiverChargeType',
            'BillThirdPartyChargeType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesBillThirdPartyChargeType',
            'BillReceiverAddressType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesBillReceiverAddressType',
            'AlternateDeliveryAddressType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesAlternateDeliveryAddressType',
            'ADRType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesADRType',
            'IndicationType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesIndicationType',
            'ShipmentServiceOptionsType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesShipmentServiceOptionsType',
            'ShipmentServiceOptionsAccessPointCODType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesShipmentServiceOptionsAccessPointCODType',
            'ReturnServiceType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesReturnServiceType',
            'ImportControlType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesImportControlType',
            'RestrictedArticlesType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesRestrictedArticlesType',
            'PickupOptionsType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesPickupOptionsType',
            'DeliveryOptionsType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesDeliveryOptionsType',
            'ShipperType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesShipperType',
            'GuaranteedDeliveryType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesGuaranteedDeliveryType',
            'FRSPaymentInfoType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesFRSPaymentInfoType',
            'FreightShipmentInformationType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesFreightShipmentInformationType',
            'PayerAddressType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesPayerAddressType',
            'FreightDensityInfoType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesFreightDensityInfoType',
            'AdjustedHeightType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesAdjustedHeightType',
            'HandlingUnitsType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesHandlingUnitsType',
            'HandlingUnitsDimensionsType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesHandlingUnitsDimensionsType',
            'InvoiceLineTotalType' => '\\Ups_rates\\UPSratesStruct\\Ups_ratesInvoiceLineTotalType',
        );
    }
}
